CREATE TABLE TMP_EXECUTION_MIGRATION LIKE EXECUTION;

INSERT INTO TMP_EXECUTION_MIGRATION (
  EXECUTION_ID,
  WORKFLOW_EXECUTION_ID,
  RESULTS_CLONED_FROM,
  CALL_FQN,
  STATUS,
  IDX,
  RC,
  START_DT,
  END_DT,
  ALLOWS_RESULT_REUSE,
  DOCKER_IMAGE_HASH,
  EXECUTION_HASH,
  ATTEMPT,
  BACKEND_TYPE
)
  SELECT
    EXECUTION_ID,
    WORKFLOW_EXECUTION_ID,
    RESULTS_CLONED_FROM,
    CALL_FQN,
    STATUS,
    IDX,
    RC,
    START_DT,
    END_DT,
    ALLOWS_RESULT_REUSE,
    DOCKER_IMAGE_HASH,
    EXECUTION_HASH,
    ATTEMPT,
    BACKEND_TYPE
  FROM EXECUTION e
  WHERE e.CALL_FQN NOT LIKE '%$%' AND  -- filter out scatters
        NOT (e.IDX = -1 AND EXISTS (   -- filter out collectors
            SELECT 1 FROM EXECUTION e2 WHERE
              e2.WORKFLOW_EXECUTION_ID = e.WORKFLOW_EXECUTION_ID AND
              e2.CALL_FQN = e.CALL_FQN AND
              e2.IDX != -1)
        );
